/*
!===============================================================================
!
! c_util.c - C utilities
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2007 Hinnerk Stueben
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
*/
# include <stdio.h>
# include <stdarg.h>
# include "c_util.h"
# include "c_defs.h"

/*---------------------------------------------------------------------------*/
void c_die(char *file, int line, char *fmt, ...)
{
  fprintf(stderr, "%s (%d): ", file, line);

  va_list args;
  va_start(args, fmt);
  vfprintf(stderr, fmt, args);
  fprintf(stderr, "\n");
  va_end(args);

  ABBRUCH();
}

/*---------------------------------------------------------------------------*/
void c_warn(char *file, int line, char *fmt, ...)
{
  fprintf(stderr, "WARNING: %s (%d): ", file, line);

  va_list args;
  va_start(args, fmt);
  vfprintf(stderr, fmt, args);
  fprintf(stderr, "\n");
  va_end(args);
}
/*===========================================================================*/
