!===============================================================================
!
! ildg_io_single_pe_r8.F90
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2007-2008 Hinnerk Stueben
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

!-------------------------------------------------------------------------------
subroutine ildg_io_r8(action, u, words, bytes)

  use module_lattice_io
  use module_vol
  implicit none
  character(*), intent(in)        :: action
  GAUGE_FIELD_ILDG, intent(inout) :: u
  INT8, intent(in)                :: words
  INT8, intent(in)                :: bytes

  if (action == "read") then
     call ildg_read(u, bytes)
  endif

  if (action == "write") then
     call swap_endian8(words, u)
     call ildg_write(u, bytes)
  endif

  call swap_endian8(words, u)
end

!===============================================================================
