!===============================================================================
!
! polyakov_loop_single_pe.F90
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2006 Hinnerk Stueben
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

!-------------------------------------------------------------------------------
subroutine polyakov_loop_aggregate(pl, tmp_polyakov, nx, ny, nz)

  implicit none
  COMPLEX, intent(out) :: pl 
  integer, intent(in)  :: nx, ny, nz
  COMPLEX, intent(in)  :: tmp_polyakov(NCOL, NCOL, 0:nx-1, 0:ny-1, 0:nz-1)
  integer              :: x, y, z
  
  pl = ZERO
  
  do z = 0, nz - 1
     do y = 0, ny - 1
        do x = 0, nx - 1
	   pl = pl + tmp_polyakov(1,1,x,y,z) &
                   + tmp_polyakov(2,2,x,y,z) &
                   + tmp_polyakov(3,3,x,y,z)
	enddo
     enddo
  enddo
  
end

!===============================================================================
