include(`defs.m4')
include(`spin_sum.m4')
include(`d100_defs.m4')
!-------------------------------------------------------------------------------
#include "defs.h"
!-------------------------------------------------------------------------------
subroutine _STRCAT(d_,NAME)(out, a_fwd, a_bwd, u, nn_fwd, nn_bwd)
  use module_vol
  implicit none
  COMPLEX, dimension (2, 3, *) :: a_fwd, a_bwd
  COMPLEX, dimension (6, 3, *) :: u
  integer(4), dimension (*) :: nn_fwd, nn_bwd
#ifdef FLIPSC
  COMPLEX, dimension (3, 4, *) :: out
#else
  COMPLEX, dimension (4, 3, *) :: out
#endif

  integer :: i, jf, jb
  COMPLEX :: a1, a2 , bf11,bf21,bf12,bf22,bf13,bf23
  COMPLEX ::          bb11,bb21,bb12,bb22,bb13,bb23
  COMPLEX :: tmp3, tmp4

  TIMING_START(_STRCAT(timing_bin_d_,NAME))

#ifdef IBM
!
! compiler takes care align for tmp variable
! so do not align tmp var
!
  call alignx(16, out(1,1,1) )
  call alignx(16, u(1,1,1))
  call alignx(16, a_fwd(1,1,1))
  call alignx(16, a_bwd(1,1,1))
#endif
  !$omp parallel do private(jf, jb, a1, a2, &
  !$omp bf11,bf21,bf12,bf22,bf13,bf23, &
  !$omp bb11,bb21,bb12,bb22,bb13,bb23, &
  !$omp tmp3, tmp4)
  do i = 1, volh
     jf=nn_fwd(i)
     jb=nn_bwd(i)
     a1=a_fwd(1, 1, jf)
     a2=a_fwd(2, 1, jf)
_SPIN12MULT_123(bf,a,1)
     a1=a_bwd(1, 1, jb)
     a2=a_bwd(2, 1, jb)
_SPIN12MULT_456(bb,a,1)
     a1=a_fwd(1, 2, jf)
     a2=a_fwd(2, 2, jf)
_SPIN12MULTADD_123(bf,a,2)
     a1=a_bwd(1, 2, jb)
     a2=a_bwd(2, 2, jb)
_SPIN12MULTADD_456(bb,a,2)
     a1=a_fwd(1, 3, jf)
     a2=a_fwd(2, 3, jf)
_SPIN12MULTADD_123(bf,a,3)
     a1=a_bwd(1, 3, jb)
     a2=a_bwd(2, 3, jb)
_SPIN12MULTADD_456(bb,a,3)

#ifdef FLIPSC
_SUM_AA(`34')
#else
_SUM_AA()
#endif
  enddo

  TIMING_STOP(_STRCAT(timing_bin_d_,NAME))

end

!===============================================================================
