!===============================================================================
!//
!// D510.F90 - multiplication with the Wilson hopping matrix D (or D^\dagger)
!//            interface to Thomas Streuer's routines
!//
!-------------------------------------------------------------------------------
!
! Copyright (C) 2006 Hinnerk Stueben
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

!-------------------------------------------------------------------------------
subroutine NAME(e, o, out, in, u)
 
!// out := NAME in 
!//
!// NAME = d or d_dag
!//
!// out is of type "e" = EVEN or ODD
!// in is of type "o" = ODD or EVEN

  use module_function_decl
  use module_vol
  implicit none
  include 'mpif.h'
 
  integer :: e, o
  SPINCOL_FIELD :: out, in
  GAUGE_FIELD :: u


  TIMING_START(STRCAT(timing_bin_, NAME))

#ifdef DAGGER
  if (e == EVEN) call w_dirac_even_dag(u, in, out, my_pe())
  if (e == ODD)  call w_dirac_odd_dag(u, in, out, my_pe())
#else
  if (e == EVEN) call w_dirac_even(u, in, out, my_pe())
  if (e == ODD)  call w_dirac_odd(u, in, out, my_pe())
#endif

  TIMING_STOP(STRCAT(timing_bin_, NAME))
end

!===============================================================================
