#===============================================================================
#
# d/D_PROJ.mk
#
#-------------------------------------------------------------------------------
#
# Copyright (C) 2010 Hinnerk Stueben
#
# This file is part of BQCD -- Berlin Quantum ChromoDynamics program
#
# BQCD is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# BQCD is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
#
#===============================================================================

OBJS_D_PROJ = \
	d_proj_xf.o \
	d_proj_xb.o \
	d_proj_yf.o \
	d_proj_yb.o \
	d_proj_zf.o \
	d_proj_zb.o \
	d_proj_tf.o \
	d_proj_tb.o \
	d_dag_proj_xf.o \
	d_dag_proj_xb.o \
	d_dag_proj_yf.o \
	d_dag_proj_yb.o \
	d_dag_proj_zf.o \
	d_dag_proj_zb.o \
	d_dag_proj_tf.o \
	d_dag_proj_tb.o


d_proj_xf.f90:      D_PROJxyzt.F90;  $(fpp) -DNAME=d_proj_xf     -UDAGGER -DDIR_X -DFORWARD D_PROJxyzt.F90 > $@

d_proj_yf.f90:      D_PROJxyzt.F90;  $(fpp) -DNAME=d_proj_yf     -UDAGGER -DDIR_Y -DFORWARD D_PROJxyzt.F90 > $@

d_proj_zf.f90:      D_PROJxyzt.F90;  $(fpp) -DNAME=d_proj_zf     -UDAGGER -DDIR_Z -DFORWARD D_PROJxyzt.F90 > $@

d_proj_tf.f90:      D_PROJxyzt.F90;  $(fpp) -DNAME=d_proj_tf     -UDAGGER -DDIR_T -DFORWARD D_PROJxyzt.F90 > $@


d_proj_xb.f90:      D_PROJxyzt.F90;  $(fpp) -DNAME=d_proj_xb     -UDAGGER -DDIR_X -UFORWARD D_PROJxyzt.F90 > $@

d_proj_yb.f90:      D_PROJxyzt.F90;  $(fpp) -DNAME=d_proj_yb     -UDAGGER -DDIR_Y -UFORWARD D_PROJxyzt.F90 > $@

d_proj_zb.f90:      D_PROJxyzt.F90;  $(fpp) -DNAME=d_proj_zb     -UDAGGER -DDIR_Z -UFORWARD D_PROJxyzt.F90 > $@

d_proj_tb.f90:      D_PROJxyzt.F90;  $(fpp) -DNAME=d_proj_tb     -UDAGGER -DDIR_T -UFORWARD D_PROJxyzt.F90 > $@


d_dag_proj_xf.f90:  D_PROJxyzt.F90;  $(fpp) -DNAME=d_dag_proj_xf -DDAGGER -DDIR_X -DFORWARD D_PROJxyzt.F90 > $@

d_dag_proj_yf.f90:  D_PROJxyzt.F90;  $(fpp) -DNAME=d_dag_proj_yf -DDAGGER -DDIR_Y -DFORWARD D_PROJxyzt.F90 > $@

d_dag_proj_zf.f90:  D_PROJxyzt.F90;  $(fpp) -DNAME=d_dag_proj_zf -DDAGGER -DDIR_Z -DFORWARD D_PROJxyzt.F90 > $@

d_dag_proj_tf.f90:  D_PROJxyzt.F90;  $(fpp) -DNAME=d_dag_proj_tf -DDAGGER -DDIR_T -DFORWARD D_PROJxyzt.F90 > $@


d_dag_proj_xb.f90:  D_PROJxyzt.F90;  $(fpp) -DNAME=d_dag_proj_xb -DDAGGER -DDIR_X -UFORWARD D_PROJxyzt.F90 > $@

d_dag_proj_yb.f90:  D_PROJxyzt.F90;  $(fpp) -DNAME=d_dag_proj_yb -DDAGGER -DDIR_Y -UFORWARD D_PROJxyzt.F90 > $@

d_dag_proj_zb.f90:  D_PROJxyzt.F90;  $(fpp) -DNAME=d_dag_proj_zb -DDAGGER -DDIR_Z -UFORWARD D_PROJxyzt.F90 > $@

d_dag_proj_tb.f90:  D_PROJxyzt.F90;  $(fpp) -DNAME=d_dag_proj_tb -DDAGGER -DDIR_T -UFORWARD D_PROJxyzt.F90 > $@


