#===============================================================================
#
# d/libd.mk
#
#-------------------------------------------------------------------------------
#
# Copyright (C) 2006-2007 Hinnerk Stueben
#
# This file is part of BQCD -- Berlin Quantum ChromoDynamics program
#
# BQCD is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# BQCD is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
#
#===============================================================================

OBJS = \
	d_init.o \
	d_g.o \
	d.o  \
	d_t.o  \
	d_zb.o \
	d_zf.o \
	d_yb.o \
	d_yf.o \
	d_xb.o \
	d_xf.o \
	d_dag.o  \
	d_dag_t.o  \
	d_dag_zb.o \
	d_dag_zf.o \
	d_dag_yb.o \
	d_dag_yf.o \
	d_dag_xb.o \
	d_dag_xf.o \
	d1_r4.o  \
	d_t_r4.o  \
	d_zb_r4.o \
	d_zf_r4.o \
	d_yb_r4.o \
	d_yf_r4.o \
	d_xb_r4.o \
	d_xf_r4.o \
	d1_dag_r4.o  \
	d_dag_t_r4.o  \
	d_dag_zb_r4.o \
	d_dag_zf_r4.o \
	d_dag_yb_r4.o \
	d_dag_yf_r4.o \
	d_dag_xb_r4.o \
	d_dag_xf_r4.o \
	d_version.o \
	d_block.o \
        d_projection.o \
        d_xbound.o

R4_FLAGS = -DPRECISION_R4 -DD_R4_INTERNAL

fast:
	$(FAST_MAKE)

d.f90: D.F90
	$(fpp) -DNAME=d D.F90 > $@

d_dag.f90: D.F90
	$(fpp) -DNAME=d_dag D.F90 > $@

d_xf.f90: Dxyz.F90
	$(fpp) -DNAME=d_xf -DDIR_X -DFORWARD -UDAGGER Dxyz.F90 > $@

d_yf.f90: Dxyz.F90
	$(fpp) -DNAME=d_yf -DDIR_Y -DFORWARD -UDAGGER Dxyz.F90 > $@

d_zf.f90: Dxyz.F90
	$(fpp) -DNAME=d_zf -DDIR_Z -DFORWARD -UDAGGER Dxyz.F90 > $@

d_dag_xf.f90: Dxyz.F90
	$(fpp) -DNAME=d_dag_xf -DDIR_X -DFORWARD -DDAGGER Dxyz.F90 > $@

d_dag_yf.f90: Dxyz.F90
	$(fpp) -DNAME=d_dag_yf -DDIR_Y -DFORWARD -DDAGGER Dxyz.F90 > $@

d_dag_zf.f90: Dxyz.F90
	$(fpp) -DNAME=d_dag_zf -DDIR_Z -DFORWARD -DDAGGER Dxyz.F90 > $@

d_xb.f90: Dxyz.F90
	$(fpp) -DNAME=d_xb -DDIR_X -UFORWARD -UDAGGER Dxyz.F90 > $@

d_yb.f90: Dxyz.F90
	$(fpp) -DNAME=d_yb -DDIR_Y -UFORWARD -UDAGGER Dxyz.F90 > $@

d_zb.f90: Dxyz.F90
	$(fpp) -DNAME=d_zb -DDIR_Z -UFORWARD -UDAGGER Dxyz.F90 > $@

d_dag_xb.f90: Dxyz.F90
	$(fpp) -DNAME=d_dag_xb -DDIR_X -UFORWARD -DDAGGER Dxyz.F90 > $@

d_dag_yb.f90: Dxyz.F90
	$(fpp) -DNAME=d_dag_yb -DDIR_Y -UFORWARD -DDAGGER Dxyz.F90 > $@

d_dag_zb.f90: Dxyz.F90
	$(fpp) -DNAME=d_dag_zb -DDIR_Z -UFORWARD -DDAGGER Dxyz.F90 > $@

d_t.f90: Dt.F90
	$(fpp) -DNAME=d_t -UDAGGER Dt.F90 > $@

d_dag_t.f90: Dt.F90
	$(fpp) -DNAME=d_dag_t -DDAGGER Dt.F90 > $@



d1_r4.f90: D.F90
	$(fpp) $(R4_FLAGS) -DNAME=d D.F90 > $@

d1_dag_r4.f90: D.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_dag D.F90 > $@

d_xf_r4.f90: Dxyz.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_xf_r4 -DDIR_X -DFORWARD -UDAGGER Dxyz.F90 > $@

d_yf_r4.f90: Dxyz.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_yf_r4 -DDIR_Y -DFORWARD -UDAGGER Dxyz.F90 > $@

d_zf_r4.f90: Dxyz.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_zf_r4 -DDIR_Z -DFORWARD -UDAGGER Dxyz.F90 > $@

d_dag_xf_r4.f90: Dxyz.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_dag_xf_r4 -DDIR_X -DFORWARD -DDAGGER Dxyz.F90 > $@

d_dag_yf_r4.f90: Dxyz.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_dag_yf_r4 -DDIR_Y -DFORWARD -DDAGGER Dxyz.F90 > $@

d_dag_zf_r4.f90: Dxyz.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_dag_zf_r4 -DDIR_Z -DFORWARD -DDAGGER Dxyz.F90 > $@

d_xb_r4.f90: Dxyz.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_xb_r4 -DDIR_X -UFORWARD -UDAGGER Dxyz.F90 > $@

d_yb_r4.f90: Dxyz.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_yb_r4 -DDIR_Y -UFORWARD -UDAGGER Dxyz.F90 > $@

d_zb_r4.f90: Dxyz.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_zb_r4 -DDIR_Z -UFORWARD -UDAGGER Dxyz.F90 > $@

d_dag_xb_r4.f90: Dxyz.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_dag_xb_r4 -DDIR_X -UFORWARD -DDAGGER Dxyz.F90 > $@

d_dag_yb_r4.f90: Dxyz.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_dag_yb_r4 -DDIR_Y -UFORWARD -DDAGGER Dxyz.F90 > $@

d_dag_zb_r4.f90: Dxyz.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_dag_zb_r4 -DDIR_Z -UFORWARD -DDAGGER Dxyz.F90 > $@

d_t_r4.f90: Dt.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_t_r4 -UDAGGER Dt.F90 > $@

d_dag_t_r4.f90: Dt.F90
	$(fpp) $(R4_FLAGS) -DNAME=d_dag_t_r4 -DDAGGER Dt.F90 > $@



d_version.f90: DVersion.F90
	$(fpp) -DVERSION=1 DVersion.F90 > $@

