#===============================================================================
#
# d/libd100.mk
#
#-------------------------------------------------------------------------------
#
# Copyright (C) 2008 Yoshifumi Nakamura
#
# This file is part of BQCD -- Berlin Quantum ChromoDynamics program
#
# BQCD is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# BQCD is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
#
#===============================================================================

FAST_MAKE = make -j 1

M4=m4

MODULES = \
	module_d21.o \
	module_d21_r4.o

OBJS = \
	d$(libd)_g.o \
	d$(libd)_version.o \
	d$(libd).o \
	dxyzt.o \
	dxyzt_block.o \
	dxyzt_r4.o \
	d$(libd)_r4.o \
	dxyzt_block_r4.o

#	d_init.o \

R4_FLAGS = -DPRECISION_R4 -DD_R4_INTERNAL

fast:
	$(MAKE) $(MODULES)
	$(FAST_MAKE)

module_d21.f90:    module_d21.F90;  $(fpp) $< > $@
module_d21_r4.f90: module_d21.F90;  $(fpp) $(R4_FLAGS) $< > $@

d100.F90:       D100.m4;       $(M4) -I../../include $(MYFLAGS) D100.m4       >d100.F90

dxyzt.F90: D$(libd)_util.m4
	$(M4) -I../../include $(MYFLAGS) -DNAME=xf     -DDIRECTION=X          D$(libd)_util.m4 > dxyzt.F90
	$(M4) -I../../include $(MYFLAGS) -DNAME=yf     -DDIRECTION=Y          D$(libd)_util.m4 >>dxyzt.F90
	$(M4) -I../../include $(MYFLAGS) -DNAME=zf     -DDIRECTION=Z          D$(libd)_util.m4 >>dxyzt.F90
	$(M4) -I../../include $(MYFLAGS) -DNAME=t      -DDIRECTION=T          D$(libd)_util.m4 >>dxyzt.F90
	$(M4) -I../../include $(MYFLAGS) -DNAME=dag_xf -DDIRECTION=X -DDAGGER D$(libd)_util.m4 >>dxyzt.F90
	$(M4) -I../../include $(MYFLAGS) -DNAME=dag_yf -DDIRECTION=Y -DDAGGER D$(libd)_util.m4 >>dxyzt.F90
	$(M4) -I../../include $(MYFLAGS) -DNAME=dag_zf -DDIRECTION=Z -DDAGGER D$(libd)_util.m4 >>dxyzt.F90
	$(M4) -I../../include $(MYFLAGS) -DNAME=dag_t  -DDIRECTION=T -DDAGGER D$(libd)_util.m4 >>dxyzt.F90

dxyzt_block.F90: D100_util_block.m4
	$(M4) -I../../include $(MYFLAGS) -DNAME=x     -DDIRECTION=X          D100_util_block.m4 > dxyzt_block.F90
	$(M4) -I../../include $(MYFLAGS) -DNAME=y     -DDIRECTION=Y          D100_util_block.m4 >>dxyzt_block.F90
	$(M4) -I../../include $(MYFLAGS) -DNAME=z     -DDIRECTION=Z          D100_util_block.m4 >>dxyzt_block.F90
	$(M4) -I../../include $(MYFLAGS) -DNAME=t     -DDIRECTION=T          D100_util_block.m4 >>dxyzt_block.F90
	$(M4) -I../../include $(MYFLAGS) -DNAME=dag_x -DDIRECTION=X -DDAGGER D100_util_block.m4 >>dxyzt_block.F90
	$(M4) -I../../include $(MYFLAGS) -DNAME=dag_y -DDIRECTION=Y -DDAGGER D100_util_block.m4 >>dxyzt_block.F90
	$(M4) -I../../include $(MYFLAGS) -DNAME=dag_z -DDIRECTION=Z -DDAGGER D100_util_block.m4 >>dxyzt_block.F90
	$(M4) -I../../include $(MYFLAGS) -DNAME=dag_t -DDIRECTION=T -DDAGGER D100_util_block.m4 >>dxyzt_block.F90

d100_g.f90:       D$(libd)_g.F90;	$(fpp) D$(libd)_g.F90 > $@
d100_version.f90: DVersion.F90; $(fpp) -DVERSION=100 DVersion.F90 > $@

d$(libd).f90: d$(libd).F90;	$(fpp) d$(libd).F90 > d$(libd).f90
dxyzt.f90: dxyzt.F90;	                $(fpp) dxyzt.F90 > $@
dxyzt_block.f90: dxyzt_block.F90;	$(fpp) dxyzt_block.F90 > $@

d100_r4.f90: d100_r4.F90;	        $(fpp) d100_r4.F90 > $@
dxyzt_r4.f90: dxyzt_r4.F90;	        $(fpp) dxyzt_r4.F90 > $@
dxyzt_block_r4.f90: dxyzt_block_r4.F90;	$(fpp) dxyzt_block_r4.F90 > $@
