#===============================================================================
#
# d/libd21.mk
#
#-------------------------------------------------------------------------------
#
# Copyright (C) 2007-2008 Hinnerk Stueben
#
# This file is part of BQCD -- Berlin Quantum ChromoDynamics program
#
# BQCD is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# BQCD is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
#
#===============================================================================

MODULES = \
	module_d21.o \
	module_d21_r4.o

OBJS = \
	d_init.o \
	d_g.o \
	d21_xbound.o \
	d21.o  \
	d21_t.o  \
	d21_zf.o \
	d21_yf.o \
	d21_xf.o \
	d21_dag.o  \
	d21_dag_t.o  \
	d21_dag_zf.o \
	d21_dag_yf.o \
	d21_dag_xf.o \
	d21_r4.o  \
	d21_t_r4.o  \
	d21_zf_r4.o \
	d21_yf_r4.o \
	d21_xf_r4.o \
	d21_dag_r4.o  \
	d21_dag_t_r4.o  \
	d21_dag_zf_r4.o \
	d21_dag_yf_r4.o \
	d21_dag_xf_r4.o \
	d21_x_block.o \
	d21_y_block.o \
	d21_z_block.o \
	d21_t_block.o \
	d21_dag_x_block.o \
	d21_dag_y_block.o \
	d21_dag_z_block.o \
	d21_dag_t_block.o \
	d21_version.o

R4_FLAGS = -DPRECISION_R4 -DD_R4_INTERNAL

fast:
	$(MAKE) $(MODULES)
	$(FAST_MAKE)

module_d21.f90:    module_d21.F90;  $(fpp) $< > $@ 

module_d21_r4.f90: module_d21.F90;  $(fpp) $(R4_FLAGS) $< > $@ 

d21_xbound.f90:    D21_xbound.F90;  $(fpp) $< > $@


d21.f90:        D21.F90;     $(fpp) -DNAME=d                -UDAGGER D21.F90 > $@

d21_dag.f90:    D21.F90;     $(fpp) -DNAME=d_dag            -DDAGGER D21.F90 > $@

d21_xf.f90:     D21xyzt.F90; $(fpp) -DNAME=d_xf     -DDIR_X -UDAGGER D21xyzt.F90 > $@

d21_yf.f90:     D21xyzt.F90; $(fpp) -DNAME=d_yf     -DDIR_Y -UDAGGER D21xyzt.F90 > $@

d21_zf.f90:     D21xyzt.F90; $(fpp) -DNAME=d_zf     -DDIR_Z -UDAGGER D21xyzt.F90 > $@

d21_dag_xf.f90: D21xyzt.F90; $(fpp) -DNAME=d_dag_xf -DDIR_X -DDAGGER D21xyzt.F90 > $@

d21_dag_yf.f90: D21xyzt.F90; $(fpp) -DNAME=d_dag_yf -DDIR_Y -DDAGGER D21xyzt.F90 > $@

d21_dag_zf.f90: D21xyzt.F90; $(fpp) -DNAME=d_dag_zf -DDIR_Z -DDAGGER D21xyzt.F90 > $@

d21_t.f90:      D21xyzt.F90; $(fpp) -DNAME=d_t      -DDIR_T -UDAGGER D21xyzt.F90 > $@

d21_dag_t.f90:  D21xyzt.F90; $(fpp) -DNAME=d_dag_t  -DDIR_T -DDAGGER D21xyzt.F90 > $@


d21_r4.f90:        D21.F90;     $(fpp) $(R4_FLAGS) -DNAME=d                   -UDAGGER D21.F90 > $@

d21_dag_r4.f90:    D21.F90;     $(fpp) $(R4_FLAGS) -DNAME=d_dag               -DDAGGER D21.F90 > $@

d21_xf_r4.f90:     D21xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_xf_r4     -DDIR_X -UDAGGER D21xyzt.F90 > $@

d21_yf_r4.f90:     D21xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_yf_r4     -DDIR_Y -UDAGGER D21xyzt.F90 > $@

d21_zf_r4.f90:     D21xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_zf_r4     -DDIR_Z -UDAGGER D21xyzt.F90 > $@

d21_dag_xf_r4.f90: D21xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_xf_r4 -DDIR_X -DDAGGER D21xyzt.F90 > $@

d21_dag_yf_r4.f90: D21xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_yf_r4 -DDIR_Y -DDAGGER D21xyzt.F90 > $@

d21_dag_zf_r4.f90: D21xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_zf_r4 -DDIR_Z -DDAGGER D21xyzt.F90 > $@

d21_t_r4.f90:      D21xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_t_r4      -DDIR_T -UDAGGER D21xyzt.F90 > $@

d21_dag_t_r4.f90:  D21xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_t_r4  -DDIR_T -DDAGGER D21xyzt.F90 > $@


d21_x_block.f90:     D21_block.F90; $(fpp)             -DNAME=d_x_block     -DDIR_X -UDAGGER D21_block.F90 > $@

d21_y_block.f90:     D21_block.F90; $(fpp)             -DNAME=d_y_block     -DDIR_Y -UDAGGER D21_block.F90 > $@

d21_z_block.f90:     D21_block.F90; $(fpp)             -DNAME=d_z_block     -DDIR_Z -UDAGGER D21_block.F90 > $@

d21_t_block.f90:     D21_block.F90; $(fpp)             -DNAME=d_t_block     -DDIR_T -UDAGGER D21_block.F90 > $@

d21_dag_x_block.f90: D21_block.F90; $(fpp)             -DNAME=d_dag_x_block -DDIR_X -DDAGGER D21_block.F90 > $@

d21_dag_y_block.f90: D21_block.F90; $(fpp)             -DNAME=d_dag_y_block -DDIR_Y -DDAGGER D21_block.F90 > $@

d21_dag_z_block.f90: D21_block.F90; $(fpp)             -DNAME=d_dag_z_block -DDIR_Z -DDAGGER D21_block.F90 > $@

d21_dag_t_block.f90: D21_block.F90; $(fpp)             -DNAME=d_dag_t_block -DDIR_T -DDAGGER D21_block.F90 > $@


d21_version.f90: DVersion.F90; $(fpp) -DVERSION=21 DVersion.F90 > $@
