#===============================================================================
#
# d/libd25.mk
#
#-------------------------------------------------------------------------------
#
# Copyright (C) 2010 Hinnerk Stueben
#
# This file is part of BQCD -- Berlin Quantum ChromoDynamics program
#
# BQCD is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# BQCD is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
#
#===============================================================================

OBJS = \
	d_init.o \
	d_g.o \
	d_projection.o \
	d2_xbound.o \
	d25.o  \
	d2_t.o  \
	d2_zf.o \
	d2_yf.o \
	d2_xf.o \
	d25_dag.o  \
	d2_dag_t.o  \
	d2_dag_zf.o \
	d2_dag_yf.o \
	d2_dag_xf.o \
	d25_r4.o  \
	d2_t_r4.o  \
	d2_zf_r4.o \
	d2_yf_r4.o \
	d2_xf_r4.o \
	d25_dag_r4.o  \
	d2_dag_t_r4.o  \
	d2_dag_zf_r4.o \
	d2_dag_yf_r4.o \
	d2_dag_xf_r4.o \
	d2_x_block.o \
	d2_y_block.o \
	d2_z_block.o \
	d2_t_block.o \
	d2_dag_x_block.o \
	d2_dag_y_block.o \
	d2_dag_z_block.o \
	d2_dag_t_block.o \
	d25_version.o

R4_FLAGS = -DPRECISION_R4 -DD_R4_INTERNAL

fast:
	$(FAST_MAKE)

d2_xbound.f90:   D2_xbound.F90; $(fpp) $< > $@


d25.f90:            D25.F90;    $(fpp)             -DNAME=d                     -UDAGGER D25.F90 > $@

d25_dag.f90:        D25.F90;    $(fpp)             -DNAME=d_dag                 -DDAGGER D25.F90 > $@

d2_xf.f90:          D2xyzt.F90; $(fpp)             -DNAME=d_xf          -DDIR_X -UDAGGER D2xyzt.F90 > $@

d2_yf.f90:          D2xyzt.F90; $(fpp)             -DNAME=d_yf          -DDIR_Y -UDAGGER D2xyzt.F90 > $@

d2_zf.f90:          D2xyzt.F90; $(fpp)             -DNAME=d_zf          -DDIR_Z -UDAGGER D2xyzt.F90 > $@

d2_dag_xf.f90:      D2xyzt.F90; $(fpp)             -DNAME=d_dag_xf      -DDIR_X -DDAGGER D2xyzt.F90 > $@

d2_dag_yf.f90:      D2xyzt.F90; $(fpp)             -DNAME=d_dag_yf      -DDIR_Y -DDAGGER D2xyzt.F90 > $@

d2_dag_zf.f90:      D2xyzt.F90; $(fpp)             -DNAME=d_dag_zf      -DDIR_Z -DDAGGER D2xyzt.F90 > $@

d2_t.f90:           D2xyzt.F90; $(fpp)             -DNAME=d_t           -DDIR_T -UDAGGER D2xyzt.F90 > $@

d2_dag_t.f90:       D2xyzt.F90; $(fpp)             -DNAME=d_dag_t       -DDIR_T -DDAGGER D2xyzt.F90 > $@


d25_r4.f90:         D25.F90;    $(fpp) $(R4_FLAGS) -DNAME=d                              D25.F90 > $@

d25_dag_r4.f90:     D25.F90;    $(fpp) $(R4_FLAGS) -DNAME=d_dag                          D25.F90 > $@

d2_xf_r4.f90:       D2xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_xf_r4       -DDIR_X -UDAGGER D2xyzt.F90 > $@

d2_yf_r4.f90:       D2xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_yf_r4       -DDIR_Y -UDAGGER D2xyzt.F90 > $@

d2_zf_r4.f90:       D2xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_zf_r4       -DDIR_Z -UDAGGER D2xyzt.F90 > $@

d2_dag_xf_r4.f90:   D2xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_xf_r4   -DDIR_X -DDAGGER D2xyzt.F90 > $@

d2_dag_yf_r4.f90:   D2xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_yf_r4   -DDIR_Y -DDAGGER D2xyzt.F90 > $@

d2_dag_zf_r4.f90:   D2xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_zf_r4   -DDIR_Z -DDAGGER D2xyzt.F90 > $@

d2_t_r4.f90:        D2xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_t_r4        -DDIR_T -UDAGGER D2xyzt.F90 > $@

d2_dag_t_r4.f90:    D2xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_t_r4    -DDIR_T -DDAGGER D2xyzt.F90 > $@


d2_x_block.f90:     D3xyzt.F90; $(fpp)             -DNAME=d_x_block     -DDIR_X -UDAGGER D3xyzt.F90 > $@

d2_y_block.f90:     D3xyzt.F90; $(fpp)             -DNAME=d_y_block     -DDIR_Y -UDAGGER D3xyzt.F90 > $@

d2_z_block.f90:     D3xyzt.F90; $(fpp)             -DNAME=d_z_block     -DDIR_Z -UDAGGER D3xyzt.F90 > $@

d2_t_block.f90:     D3xyzt.F90; $(fpp)             -DNAME=d_t_block     -DDIR_T -UDAGGER D3xyzt.F90 > $@

d2_dag_x_block.f90: D3xyzt.F90; $(fpp)             -DNAME=d_dag_x_block -DDIR_X -DDAGGER D3xyzt.F90 > $@

d2_dag_y_block.f90: D3xyzt.F90; $(fpp)             -DNAME=d_dag_y_block -DDIR_Y -DDAGGER D3xyzt.F90 > $@

d2_dag_z_block.f90: D3xyzt.F90; $(fpp)             -DNAME=d_dag_z_block -DDIR_Z -DDAGGER D3xyzt.F90 > $@

d2_dag_t_block.f90: D3xyzt.F90; $(fpp)             -DNAME=d_dag_t_block -DDIR_T -DDAGGER D3xyzt.F90 > $@


d2_x_block_r4.f90:     D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_x_block_r4     -DDIR_X -UDAGGER D3xyzt.F90 > $@

d2_y_block_r4.f90:     D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_y_block_r4     -DDIR_Y -UDAGGER D3xyzt.F90 > $@

d2_z_block_r4.f90:     D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_z_block_r4     -DDIR_Z -UDAGGER D3xyzt.F90 > $@

d2_t_block_r4.f90:     D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_t_block_r4     -DDIR_T -UDAGGER D3xyzt.F90 > $@

d2_dag_x_block_r4.f90: D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_x_block_r4 -DDIR_X -DDAGGER D3xyzt.F90 > $@

d2_dag_y_block_r4.f90: D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_y_block_r4 -DDIR_Y -DDAGGER D3xyzt.F90 > $@

d2_dag_z_block_r4.f90: D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_z_block_r4 -DDIR_Z -DDAGGER D3xyzt.F90 > $@

d2_dag_t_block_r4.f90: D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_t_block_r4 -DDIR_T -DDAGGER D3xyzt.F90 > $@


d25_version.f90: DVersion.F90; $(fpp) -DVERSION=25 DVersion.F90 > $@
