#===============================================================================
#
# d/libd3.mk
#
#-------------------------------------------------------------------------------
#
# Copyright (C) 2006-2007 Hinnerk Stueben
#
# This file is part of BQCD -- Berlin Quantum ChromoDynamics program
#
# BQCD is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# BQCD is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
#
#===============================================================================

OBJS = \
	d_init.o \
	d_g.o \
	d3.o  \
	d3_t.o  \
	d3_zf.o \
	d3_yf.o \
	d3_xf.o \
	d3_dag.o  \
	d3_dag_t.o  \
	d3_dag_zf.o \
	d3_dag_yf.o \
	d3_dag_xf.o \
	d3_r4.o  \
	d3_t_r4.o  \
	d3_zf_r4.o \
	d3_yf_r4.o \
	d3_xf_r4.o \
	d3_dag_r4.o  \
	d3_dag_t_r4.o  \
	d3_dag_zf_r4.o \
	d3_dag_yf_r4.o \
	d3_dag_xf_r4.o \
	d3_version.o \
	d_block.o \
        d_projection.o \
        d_xbound.o

R4_FLAGS = -DPRECISION_R4 -DD_R4_INTERNAL

fast:
	$(FAST_MAKE)

d3.f90:        D3.F90;     $(fpp) -DNAME=d     D3.F90 > $@

d3_dag.f90:    D3.F90;     $(fpp) -DNAME=d_dag D3.F90 > $@

d3_xf.f90:     D3xyzt.F90; $(fpp) -DNAME=d_xf     -DDIR_X -UDAGGER D3xyzt.F90 > $@

d3_yf.f90:     D3xyzt.F90; $(fpp) -DNAME=d_yf     -DDIR_Y -UDAGGER D3xyzt.F90 > $@

d3_zf.f90:     D3xyzt.F90; $(fpp) -DNAME=d_zf     -DDIR_Z -UDAGGER D3xyzt.F90 > $@

d3_dag_xf.f90: D3xyzt.F90; $(fpp) -DNAME=d_dag_xf -DDIR_X -DDAGGER D3xyzt.F90 > $@

d3_dag_yf.f90: D3xyzt.F90; $(fpp) -DNAME=d_dag_yf -DDIR_Y -DDAGGER D3xyzt.F90 > $@

d3_dag_zf.f90: D3xyzt.F90; $(fpp) -DNAME=d_dag_zf -DDIR_Z -DDAGGER D3xyzt.F90 > $@

d3_t.f90:      D3xyzt.F90; $(fpp) -DNAME=d_t      -DDIR_T -UDAGGER D3xyzt.F90 > $@

d3_dag_t.f90:  D3xyzt.F90; $(fpp) -DNAME=d_dag_t  -DDIR_T -DDAGGER D3xyzt.F90 > $@


d3_r4.f90:        D3.F90;     $(fpp) $(R4_FLAGS) -DNAME=d     D3.F90 > $@

d3_dag_r4.f90:    D3.F90;     $(fpp) $(R4_FLAGS) -DNAME=d_dag D3.F90 > $@

d3_xf_r4.f90:     D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_xf_r4     -DDIR_X -UDAGGER D3xyzt.F90 > $@

d3_yf_r4.f90:     D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_yf_r4     -DDIR_Y -UDAGGER D3xyzt.F90 > $@

d3_zf_r4.f90:     D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_zf_r4     -DDIR_Z -UDAGGER D3xyzt.F90 > $@

d3_dag_xf_r4.f90: D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_xf_r4 -DDIR_X -DDAGGER D3xyzt.F90 > $@

d3_dag_yf_r4.f90: D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_yf_r4 -DDIR_Y -DDAGGER D3xyzt.F90 > $@

d3_dag_zf_r4.f90: D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_zf_r4 -DDIR_Z -DDAGGER D3xyzt.F90 > $@

d3_t_r4.f90:      D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_t_r4      -DDIR_T -UDAGGER D3xyzt.F90 > $@

d3_dag_t_r4.f90:  D3xyzt.F90; $(fpp) $(R4_FLAGS) -DNAME=d_dag_t_r4  -DDIR_T -DDAGGER D3xyzt.F90 > $@


d3_version.f90: DVersion.F90; $(fpp) -DVERSION=3 DVersion.F90 > $@
