#===============================================================================
#
# d/libd501.mk - Thomas Streuer's assembler for BlueGene/L
#                including process mapping, which has to be set in 
#                wilson_d501/Makefile (see wilson_d501 README)
#
#-------------------------------------------------------------------------------
#
# Copyright (C) 2006-2007 Hinnerk Stueben
#
# This file is part of BQCD -- Berlin Quantum ChromoDynamics program
#
# BQCD is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# BQCD is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
#
#===============================================================================

OBJS = \
	d500_init.o \
	d_g.o \
	d500.o  \
	d500_dag.o  \
	d501_version.o \
	wilson_d501/neighb.o \
	wilson_d501/dirac.o \
	wilson_d501/adirac.o \
	wilson_d501/shm.o \
	wilson_d501/test_t.o \
	wilson_d501/gs.o \
	wilson_d501/bgl_comm.o

fast:
	$(MAKE)  # no parallel make in wilson_d501

d500_init.f90: D500_init.F90
	$(fpp) D500_init.F90 > $@

d500.f90:     D500.F90; $(fpp) -DNAME=d     -UDAGGER D500.F90 > $@

d500_dag.f90: D500.F90; $(fpp) -DNAME=d_dag -DDAGGER D500.F90 > $@

d501_version.f90: DVersion.F90; $(fpp) -DVERSION=501 DVersion.F90 > $@

wilson_d501/adirac.o \
wilson_d501/bgl_comm.o \
wilson_d501/dirac.o \
wilson_d501/gs.o \
wilson_d501/neighb.o \
wilson_d501/shm.o \
wilson_d501/test_t.o:
	cd wilson_d501; $(MAKE) lib
