#===============================================================================
#
# d/libd511.mk - Thomas Streuer's assembler for Altix (more than 1 node)
#
#-------------------------------------------------------------------------------
#
# Copyright (C) 2006-2007 Hinnerk Stueben
#
# This file is part of BQCD -- Berlin Quantum ChromoDynamics program
#
# BQCD is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# BQCD is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
#
#===============================================================================

OBJS = \
	d510_init.o \
	d_g.o \
	d510.o  \
	d510_dag.o  \
	d511_version.o \
	wilson_d511/neighb.o \
	wilson_d511/adirac.o

fast:
	$(MAKE)  # no parallel make in wilson_d511

d510_init.f90: D510_init.F90
	$(fpp) D510_init.F90 > $@

d510.f90:     D510.F90; $(fpp) -DNAME=d     -UDAGGER D510.F90 > $@

d510_dag.f90: D510.F90; $(fpp) -DNAME=d_dag -DDAGGER D510.F90 > $@

d511_version.f90: DVersion.F90; $(fpp) -DVERSION=511 DVersion.F90 > $@

wilson_d511/adirac.o wilson_d511/neighb.o:
	cd wilson_d511; $(MAKE) lib
