#===============================================================================
#
# d/libd520.mk
#
#-------------------------------------------------------------------------------
#
# Copyright (C) 2010 Hinnerk Stueben
#
# This file is part of BQCD -- Berlin Quantum ChromoDynamics program
#
# BQCD is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# BQCD is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
#
#===============================================================================

#MODULES = \
#	module_d4.o \
#	module_d4_r4.o

OBJS = \
	d_r4.o\
	d520_init.o \
	d520_g.o \
	d520.o  \
	d520_dag.o  \
	d520_version.o \
	d_block.o \
        d_projection.o \
        d_xbound.o \
        wilson_d520/neighb.o \
        wilson_d520/lattice_bqcd.o \
        wilson_d520/globals.o \
        wilson_d520/adirac.o

#	d45_r4.o  \
#	d4_bwd_r4.o  \
#	d4_fwd_r4.o  \
#	d45_dag_r4.o  \
#	d4_dag_bwd_r4.o  \
#	d4_dag_fwd_r4.o  \
#	d4_bwd.o  \
#	d4_fwd.o  \
#	d4_dag_bwd.o  \
#	d4_dag_fwd.o  \
#	d4_g_r4.o \

R4_FLAGS = -DPRECISION_R4 -DD_R4_INTERNAL

fast:
	$(MAKE) $(MODULES)    # no parallel make in wilson_d520
	$(MAKE)


wilson_d520/adirac.o wilson_d520/neighb.o wilson_d520/lattice_bqcd.o wilson_d520/globals.o:
	cd wilson_d520; $(MAKE) lib


#module_d4.f90:      module_d8.F90;   $(fpp)                           $< > $@

#module_d4_r4.f90:   module_d8.F90;   $(fpp) $(R4_FLAGS)               $< > $@ 

d520_g.f90:           D520_g.F90;      $(fpp)                           $< > $@ 

#d4_g_r4.f90:        D8_g_r4.F90;     $(fpp)                           $< > $@ 


#d4_bwd.f90:         D4_bwd.F90;      $(fpp)                           $< > $@ 

#d4_fwd.f90:         D4_fwd.F90;      $(fpp)                           $< > $@ 

#d4_dag_bwd.f90:     D4_dag_bwd.F90;  $(fpp)                           $< > $@ 

#d4_dag_fwd.f90:     D4_dag_fwd.F90;  $(fpp)                           $< > $@ 


#d45_r4.f90:         D45.F90;         $(fpp) $(R4_FLAGS) -DNAME=d     -UDAGGER $< > $@ 

#d45_dag_r4.f90:     D45.F90;         $(fpp) $(R4_FLAGS) -DNAME=d_dag -DDAGGER $< > $@ 

#d4_bwd_r4.f90:      D4_bwd.F90;      $(fpp) $(R4_FLAGS)               $< > $@ 

#d4_fwd_r4.f90:      D4_fwd.F90;      $(fpp) $(R4_FLAGS)               $< > $@ 

#d4_dag_bwd_r4.f90:  D4_dag_bwd.F90;  $(fpp) $(R4_FLAGS)               $< > $@ 

#d4_dag_fwd_r4.f90:  D4_dag_fwd.F90;  $(fpp) $(R4_FLAGS)               $< > $@ 


d520_version.f90:    DVersion.F90;    $(fpp) -DVERSION=520            $< > $@


d520_init.f90: D520_init.F90
	$(fpp) D520_init.F90 > $@

d520.f90:     D520.F90; $(fpp) -DNAME=d     -UDAGGER D520.F90 > $@

d520_dag.f90: D520.F90; $(fpp) -DNAME=d_dag -DDAGGER D520.F90 > $@

