include(`defs.m4')
include(`spin_dcmp.m4')
include(`dsf.m4')
!===============================================================================
!
! dsf_xyzt_dd.m4
!
! input   b, a   spinor field
!         nn     nearest neighbor indicator list
! output  w      su(n) field
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2009-2010 Yoshifumi Nakamura
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

!-------------------------------------------------------------------------------
subroutine _STRCAT(dsf_f,NDCMP,_dd)(w, b, a, eo, dm)
  use module_vol
  use module_dd
  use module_function_decl
  implicit none
  complex(8), dimension(3,3,volh_tot), intent(out) :: w
  complex(8), dimension(4,3,ld%lat%volh,0:ld%lat%num_ip-1), intent(in):: b, a
  integer, intent(in) :: eo, dm
  complex(8), dimension(3,3,ld%lat%volh,0:ld%lat%num_ip-1):: w_ip
  complex(8), dimension(4,3,ld%lat%volh_tot)              :: b_ip, a_ip
  integer :: i, ip, di, dp, c1, c2

  w_ip=0
  do ip=0,ld%lat%num_ip-1
     if (dm==2 .or. eo_dm(ip) == dm) then
     a_ip=0
     b_ip=0
     a_ip(1:4,1:3,1:ld%lat%volh)=a(1:4,1:3,1:ld%lat%volh,ip)
     b_ip(1:4,1:3,1:ld%lat%volh)=b(1:4,1:3,1:ld%lat%volh,ip)

     call _STRCAT(dsf_f,NDCMP,_ddeo_ip)(w_ip(1,1,1,ip), b_ip,a_ip, &
          ldnn(ip)%nn(      1,eo, DIR ,FWD), &
          ldnn(ip)%count_dd(  eo, DIR ,FWD), &
          ldnn(ip)%volh_dd( 1,eo, DIR ,FWD))
     endif
  enddo
  do i = 1, volh
     di = ddi( i,eo)
!!     de = ddeo(i,eo)
     dp = ddip(i,eo)
     do c1 = 1, NCOL
     do c2 = 1, NCOL
        w(c1,c2,i)=w_ip(c1,c2,di,dp)
     enddo
     enddo
  enddo
end

!-------------------------------------------------------------------------------
subroutine _STRCAT(dsf_b,NDCMP,_dd)(w, b, a, eo, dm)
  use module_vol
  use module_dd
  use module_function_decl
  implicit none
  complex(8), dimension(3,3,volh_tot), intent(out) :: w
  complex(8), dimension(4,3,ld%lat%volh,0:ld%lat%num_ip-1), intent(in):: b, a
  integer, intent(in) :: eo, dm
  complex(8), dimension(3,3,ld%lat%volh,0:ld%lat%num_ip-1):: w_ip
  complex(8), dimension(4,3,ld%lat%volh_tot)              :: b_ip, a_ip
  integer :: i, ip, di, dp, c1, c2

  w_ip=0
  do ip=0,ld%lat%num_ip-1
     if (dm==2 .or. eo_dm(ip) == dm) then
     a_ip=0
     b_ip=0
     a_ip(1:4,1:3,1:ld%lat%volh)=a(1:4,1:3,1:ld%lat%volh,ip)
     b_ip(1:4,1:3,1:ld%lat%volh)=b(1:4,1:3,1:ld%lat%volh,ip)

     call _STRCAT(dsf_b,NDCMP,_ddeo_ip)(w_ip(1,1,1,ip), b_ip,a_ip, &
          ldnn(ip)%nn(      1,eo, DIR ,FWD), &
          ldnn(ip)%count_dd(  eo, DIR ,FWD), &
          ldnn(ip)%volh_dd( 1,eo, DIR ,FWD))
     endif
  enddo
  do i = 1, volh
     di = ddi( i,eo)
!!     de = ddeo(i,eo)
     dp = ddip(i,eo)
     do c1 = 1, NCOL
     do c2 = 1, NCOL
        w(c1,c2,i)=w_ip(c1,c2,di,dp)
     enddo
     enddo
  enddo
end

!-------------------------------------------------------------------------------
subroutine _STRCAT(dsf_f,NDCMP,_eo)(w, b, a, eo, dm)
  use module_vol
  use module_dd
  use module_xbound_sc_dd
  use module_function_decl
  implicit none
  complex(8), dimension(3,3,volh_tot), intent(out) :: w
  complex(8), dimension(4,3,ld%lat%volh,0:ld%lat%num_ip-1), intent(in):: b, a
  integer, intent(in) :: eo, dm
  complex(8), dimension(3,3,ld%lat%volh,0:ld%lat%num_ip-1):: w_ip
  complex(8), dimension(4,3,ld%lat%volh_tot)              :: b_ip, a_ip, tmp
  integer :: i, ip, di, dp, c1, c2

  w_ip=0
  do ip=0,ld%lat%num_ip-1
     if (dm==2 .or. eo_dm(ip) == dm) then
     a_ip=0
     b_ip=0
     tmp=0

     i = xbsc(ip)%i_bound( DIR , FWD )
     if (i /= 0) then
        tmp(1:4,1:3,1:ld%lat%volh)=a(1:4,1:3,1:ld%lat%volh,xbsc(ip)%b(i)%dm_source)
        if (my_pe() == xbsc(ip)%b(i)%pe_source) then
        call xbound_sc2_dd_cp(xbsc(ip)%b(i)%block_count, &
                              xbsc(ip)%b(i)%block_size, &
                              xbsc(ip)%b(i)%block_stride, &
                     a_ip(1,1,xbsc(ip)%b(i)%i_target), &
                      tmp(1,1,xbsc(ip)%b(i)%i_source))
        else
#ifndef NONMPI
!!        a_ip(1:4,1:3,1:ld%lat%volh)=a(1:4,1:3,1:ld%lat%volh,ip) !! wrong?!
        a_ip(1:4,1:3,1:ld%lat%volh)=a(1:4,1:3,1:ld%lat%volh,xbsc(ip)%b(i)%dm_source)
        call xbound_sc_dd_mpi(a_ip,xbsc(ip)%b(i), DIR ,FWD )
#endif
        endif
     endif
     b_ip(1:4,1:3,1:ld%lat%volh)=b(1:4,1:3,1:ld%lat%volh,ip)

     call _STRCAT(dsf_f,NDCMP,_ddeo_ip)(w_ip(1,1,1,ip), b_ip,a_ip, &
          ldnn(ip)%nn(      1,eo, DIR ,FWD), &
          ldnn(ip)%count_eo(  eo, DIR ,FWD), &
          ldnn(ip)%volh_eo( 1,eo, DIR ,FWD))
     endif
  enddo
  do i = 1, volh
     di = ddi( i,eo)
!!     de = ddeo(i,eo)
     dp = ddip(i,eo)
     do c1 = 1, NCOL
     do c2 = 1, NCOL
        w(c1,c2,i)=w_ip(c1,c2,di,dp)
     enddo
     enddo
  enddo
end

!-------------------------------------------------------------------------------
subroutine _STRCAT(dsf_b,NDCMP,_eo)(w, b, a, eo, dm)
  use module_vol
  use module_dd
  use module_xbound_sc_dd
  use module_function_decl
  implicit none
  complex(8), dimension(3,3,volh_tot), intent(out) :: w
  complex(8), dimension(4,3,ld%lat%volh,0:ld%lat%num_ip-1), intent(in):: b, a
  integer, intent(in) :: eo, dm
  complex(8), dimension(3,3,ld%lat%volh,0:ld%lat%num_ip-1):: w_ip
  complex(8), dimension(4,3,ld%lat%volh_tot)              :: b_ip, a_ip, tmp
  integer :: i, ip, di, dp, c1, c2

  w_ip=0
  do ip=0,ld%lat%num_ip-1
     if (dm==2 .or. eo_dm(ip) == dm) then
     a_ip=0
     b_ip=0
     tmp=0

     i = xbsc(ip)%i_bound( DIR , FWD )
     if (i /= 0) then
        tmp(1:4,1:3,1:ld%lat%volh)=b(1:4,1:3,1:ld%lat%volh,xbsc(ip)%b(i)%dm_source)
        if (my_pe() == xbsc(ip)%b(i)%pe_source) then
        call xbound_sc2_dd_cp(xbsc(ip)%b(i)%block_count, &
                              xbsc(ip)%b(i)%block_size, &
                              xbsc(ip)%b(i)%block_stride, &
                     b_ip(1,1,xbsc(ip)%b(i)%i_target), &
                      tmp(1,1,xbsc(ip)%b(i)%i_source))
        else
#ifndef NONMPI
!!        b_ip(1:4,1:3,1:ld%lat%volh)=b(1:4,1:3,1:ld%lat%volh,ip) !! wrong
        b_ip(1:4,1:3,1:ld%lat%volh)=b(1:4,1:3,1:ld%lat%volh,xbsc(ip)%b(i)%dm_source)
        call xbound_sc_dd_mpi(b_ip,xbsc(ip)%b(i), DIR ,FWD )
#endif
        endif
     endif
     a_ip(1:4,1:3,1:ld%lat%volh)=a(1:4,1:3,1:ld%lat%volh,ip)

     call _STRCAT(dsf_b,NDCMP,_ddeo_ip)(w_ip(1,1,1,ip), b_ip,a_ip, &
          ldnn(ip)%nn(      1,eo, DIR ,FWD), &
          ldnn(ip)%count_eo(  eo, DIR ,FWD), &
          ldnn(ip)%volh_eo( 1,eo, DIR ,FWD))
     endif
  enddo
  do i = 1, volh
     di = ddi( i,eo)
!!     de = ddeo(i,eo)
     dp = ddip(i,eo)
     do c1 = 1, NCOL
     do c2 = 1, NCOL
        w(c1,c2,i)=w_ip(c1,c2,di,dp)
     enddo
     enddo
  enddo
end

!===============================================================================
