include(`defs.m4')
include(`spin_dcmp.m4')
include(`dsf.m4')
!===============================================================================
!
! dsf_xyzt_dd_ip.m4
!
! input   b, a   spinor field
!         nn     nearest neighbor indicator list
! output  w      su(n) field
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2009-2010 Yoshifumi Nakamura
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"
!-------------------------------------------------------------------------------
subroutine _STRCAT(dsf_f,NDCMP,_ddeo_ip)(w, b, a, nn, count, volh_ddeo)
  use module_dd
  implicit none
  complex(8), dimension(3,3,ld%lat%volh), intent(out) :: w
  complex(8), dimension(4,3,ld%lat%volh_tot), intent(in):: b, a
  complex(8), dimension(4) :: aa
  integer(4), intent(in) :: nn(*), count, volh_ddeo(*)
  integer :: i, j, k, ca, cb

  do k = 1, count
     i = volh_ddeo(k)
     j = nn(i)
_SPIN_SPIN(DDCMP(aa,a,ca,j),i)
  enddo
end
!-------------------------------------------------------------------------------
subroutine _STRCAT(dsf_b,NDCMP,_ddeo_ip)(w, b, a, nn, count, volh_ddeo)
  use module_dd
  implicit none
  complex(8), dimension(3,3,ld%lat%volh), intent(out) :: w
  complex(8), dimension(4,3,ld%lat%volh_tot), intent(in):: b, a
  complex(8), dimension(4) :: aa
  integer(4), intent(in) :: nn(*), count, volh_ddeo(*)
  integer :: i, j, k, ca, cb

  do k = 1, count
     i = volh_ddeo(k)
     j = nn(i)
_SPIN_SPIN(DDCMP(aa,a,ca,i),j)
  enddo
end
!===============================================================================
