include(`defs.m4')
include(`spin_dcmp.m4')
include(`dsf.m4')
!===============================================================================
!
! dsf_xyzt.m4
!
! input   b, a   spinor field
!         nn     nearest neighbor indicator list
! output  w      su(n) field
!
! - available all gamma notation, 14.01.2009, yn
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2009 Yoshifumi Nakamura
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"
!-------------------------------------------------------------------------------
subroutine _STRCAT(dsf_f,NDCMP)(w, b, a, nn)
  use module_vol
  implicit none
  complex(8), dimension(3, 3, volh_tot), intent(out) :: w
  complex(8), dimension(4, 3, volh_tot), intent(in)  :: b, a
  complex(8), dimension(4) :: aa
  integer(4), intent(in) :: nn(volh_tot)
  integer :: i, j, ca, cb

  !$omp parallel do private(j, ca, cb, aa)
  do i = 1, volh
     j = nn(i)
_SPIN_SPIN(DDCMP(aa,a,ca,j),i)
  enddo

end

!-------------------------------------------------------------------------------
subroutine _STRCAT(dsf_b,NDCMP)(w, b, a, nn)
  use module_vol
  implicit none
  complex(8), dimension(3, 3, volh_tot), intent(out) :: w
  complex(8), dimension(4, 3, volh_tot), intent(in)  :: b, a
  complex(8), dimension(4) :: aa
  integer(4), intent(in) :: nn(volh_tot)
  integer :: i, j, ca, cb

  !$omp parallel do private(j, ca, cb, aa)
  do i = 1, volh
     j = nn(i)
_SPIN_SPIN(DDCMP(aa,a,ca,i),j)
  enddo

end

!===============================================================================
