//#include <vector.h>
//#include <emmintrin.h>
//typedef double v2 __attribute__ ((vector_size (16)));
//typedef struct
//{
//  double c[2];
//} d2 __attribute__ ((aligned (16)));

/*
 * 
 * clover_mult_ao for chiral gamma notation
 * I use double _Complex as vector unit, this is slow
 *  
 */

#include <complex.h>
void clover_mult_ao_vec(double* a, double* x)
{
  //  vector double av[36];
  double _Complex av[36], xv[12] , tmpr,tmpi;
  //  __attribute__ ((aligned (16)));
   //#pragma disjoint(av,xv)
  unsigned i,j;
  __alignx(16,tmpr);
  __alignx(16,tmpi);
  __alignx(16,av);
  __alignx(16,xv);
  __alignx(16,a);
  __alignx(16,x);
  for (i=0; i<36; ++i){
    //    for (j=0; j<2; ++j){
    //      av[i][j] = a[i+36*j];
      //    }
    av[i] = __cmplx(a[i],a[i+36]);
  }
  xv[0] = __cmplx(x[0],x[4]);
  xv[1] = __cmplx(x[1],x[5]);
  xv[2] = __cmplx(x[8+0],x[8+4]);
  xv[3] = __cmplx(x[8+1],x[8+5]);
  xv[4] = __cmplx(x[16+0],x[16+4]);
  xv[5] = __cmplx(x[16+1],x[16+5]);
  xv[6] = __cmplx(x[2+0],x[2+4]);
  xv[7] = __cmplx(x[2+1],x[2+5]);
  xv[8] = __cmplx(x[10+0],x[10+4]);
  xv[9] = __cmplx(x[10+1],x[10+5]);
  xv[10] = __cmplx(x[18+0],x[18+4]);
  xv[11] = __cmplx(x[18+1],x[18+5]);



  // y1 = real(a(1)) * x1 + a(2) * x2 + a(3) * x3  + a(4) * x4 + a(5) * x5 + a(6) * x6
  tmpr=__fpmul(av[0],xv[0]); 
  for (i=1; i<6; ++i){
    tmpr=__fpmadd( tmpr,av[2*i  ],xv[2*i  ]);
    tmpr=__fpnmsub(tmpr,av[2*i+1],xv[2*i+1]);
  }
  tmpi=__fpmul(av[0],xv[1]); 
  for (i=1; i<6; ++i){
    tmpi=__fpmadd(tmpi,av[2*i  ],xv[2*i+1]);
    tmpi=__fpmadd(tmpi,av[2*i+1],xv[2*i  ]);
  }
  x[0]=__creal(tmpr);
  x[4]=__cimag(tmpr);
  x[1]=__creal(tmpi);
  x[5]=__cimag(tmpi);

  // y2 = conjg(a(2)) * x1 + aimag(a(1)) * x2 + a(7) * x3  + a(8) * x4 + a(9) * x5 + a(10) * x6
  tmpr=__fpmul(av[1],xv[2]);
  tmpr=__fpmadd( tmpr,av[2  ],xv[0 ]);
  tmpr=__fpmadd( tmpr,av[3  ],xv[1 ]);
  tmpr=__fpmadd( tmpr,av[12 ],xv[4 ]);
  tmpr=__fpnmsub(tmpr,av[13 ],xv[5 ]);
  tmpr=__fpmadd( tmpr,av[14 ],xv[6 ]);
  tmpr=__fpnmsub(tmpr,av[15 ],xv[7 ]);
  tmpr=__fpmadd( tmpr,av[16 ],xv[8 ]);
  tmpr=__fpnmsub(tmpr,av[17 ],xv[9 ]);
  tmpr=__fpmadd( tmpr,av[18 ],xv[10]);
  tmpr=__fpnmsub(tmpr,av[19 ],xv[11]);

  tmpi=__fpmul(av[1],xv[3]);
  tmpi=__fpmadd( tmpi,av[2  ],xv[1 ]);
  tmpi=__fpnmsub(tmpi,av[3  ],xv[0 ]);
  tmpi=__fpmadd(tmpi,av[12 ],xv[5 ]);
  tmpi=__fpmadd(tmpi,av[13 ],xv[4 ]);
  tmpi=__fpmadd(tmpi,av[14 ],xv[7 ]);
  tmpi=__fpmadd(tmpi,av[15 ],xv[6 ]);
  tmpi=__fpmadd(tmpi,av[16 ],xv[9 ]);
  tmpi=__fpmadd(tmpi,av[17 ],xv[8 ]);
  tmpi=__fpmadd(tmpi,av[18 ],xv[11]);
  tmpi=__fpmadd(tmpi,av[19 ],xv[10]);
  x[8+0]=__creal(tmpr);
  x[8+4]=__cimag(tmpr);
  x[8+1]=__creal(tmpi);
  x[8+5]=__cimag(tmpi);

  // y3 = conjg(a(3)) * x1 + conjg(a(7)) * x2 + real(a(11)) * x3  + a(12) * x4 + a(13) * x5 + a(14) * x6
  tmpr=__fpmul(av[20],xv[4]);
  tmpr=__fpmadd( tmpr,av[4  ],xv[0 ]);
  tmpr=__fpmadd( tmpr,av[5  ],xv[1 ]);
  tmpr=__fpmadd( tmpr,av[12 ],xv[2 ]);
  tmpr=__fpmadd( tmpr,av[13 ],xv[3 ]);
  tmpr=__fpmadd( tmpr,av[22 ],xv[6 ]);
  tmpr=__fpnmsub(tmpr,av[23 ],xv[7 ]);
  tmpr=__fpmadd( tmpr,av[24 ],xv[8 ]);
  tmpr=__fpnmsub(tmpr,av[25 ],xv[9 ]);
  tmpr=__fpmadd( tmpr,av[26 ],xv[10]);
  tmpr=__fpnmsub(tmpr,av[27 ],xv[11]);

  tmpi=__fpmul(av[20],xv[5]);
  tmpi=__fpmadd( tmpi,av[4  ],xv[1 ]);
  tmpi=__fpnmsub(tmpi,av[5  ],xv[0 ]);
  tmpi=__fpmadd( tmpi,av[12 ],xv[3 ]);
  tmpi=__fpnmsub(tmpi,av[13 ],xv[2 ]);
  tmpi=__fpmadd(tmpi,av[22 ],xv[7 ]);
  tmpi=__fpmadd(tmpi,av[23 ],xv[6 ]);
  tmpi=__fpmadd(tmpi,av[24 ],xv[9 ]);
  tmpi=__fpmadd(tmpi,av[25 ],xv[8 ]);
  tmpi=__fpmadd(tmpi,av[26 ],xv[11]);
  tmpi=__fpmadd(tmpi,av[27 ],xv[10]);
  x[16+0]=__creal(tmpr);
  x[16+4]=__cimag(tmpr);
  x[16+1]=__creal(tmpi);
  x[16+5]=__cimag(tmpi);

  //  y4 = conjg(a(4)) * x1 + conjg(a(8)) * x2 + conjg(a(12)) * x3 + aimag(a(11)) * x4 + a(15) * x5 + a(16) * x6
  tmpr=__fpmul(av[21],xv[6]);
  tmpr=__fpmadd( tmpr,av[6  ],xv[0 ]);
  tmpr=__fpmadd( tmpr,av[7  ],xv[1 ]);
  tmpr=__fpmadd( tmpr,av[14 ],xv[2 ]);
  tmpr=__fpmadd( tmpr,av[15 ],xv[3 ]);
  tmpr=__fpmadd( tmpr,av[22 ],xv[4 ]);
  tmpr=__fpmadd( tmpr,av[23 ],xv[5 ]);

  tmpr=__fpmadd( tmpr,av[28 ],xv[8 ]);
  tmpr=__fpnmsub(tmpr,av[29 ],xv[9 ]);
  tmpr=__fpmadd( tmpr,av[30 ],xv[10]);
  tmpr=__fpnmsub(tmpr,av[31 ],xv[11]);

  tmpi=__fpmul(av[21],xv[7]);
  tmpi=__fpmadd( tmpi,av[6  ],xv[1 ]);
  tmpi=__fpnmsub(tmpi,av[7  ],xv[0 ]);
  tmpi=__fpmadd( tmpi,av[14 ],xv[3 ]);
  tmpi=__fpnmsub(tmpi,av[15 ],xv[2 ]);
  tmpi=__fpmadd( tmpi,av[22 ],xv[5 ]);
  tmpi=__fpnmsub(tmpi,av[23 ],xv[4 ]);

  tmpi=__fpmadd(tmpi,av[28 ],xv[9 ]);
  tmpi=__fpmadd(tmpi,av[29 ],xv[8 ]);
  tmpi=__fpmadd(tmpi,av[30 ],xv[11]);
  tmpi=__fpmadd(tmpi,av[31 ],xv[10]);
  x[2+0]=__creal(tmpr);
  x[2+4]=__cimag(tmpr);
  x[2+1]=__creal(tmpi);
  x[2+5]=__cimag(tmpi);

  // y5 = conjg(a(5)) * x1 + conjg(a(9)) * x2 + conjg(a(13)) * x3 + conjg(a(15)) * x4 + real(a(17)) * x5 + a(18) * x6
  tmpr=__fpmul(av[32],xv[8]);
  tmpr=__fpmadd( tmpr,av[8  ],xv[0 ]);
  tmpr=__fpmadd( tmpr,av[9  ],xv[1 ]);
  tmpr=__fpmadd( tmpr,av[16 ],xv[2 ]);
  tmpr=__fpmadd( tmpr,av[17 ],xv[3 ]);
  tmpr=__fpmadd( tmpr,av[24 ],xv[4 ]);
  tmpr=__fpmadd( tmpr,av[25 ],xv[5 ]);
  tmpr=__fpmadd( tmpr,av[28 ],xv[6 ]);
  tmpr=__fpmadd( tmpr,av[29 ],xv[7 ]);
  tmpr=__fpmadd( tmpr,av[34 ],xv[10]);
  tmpr=__fpnmsub(tmpr,av[35 ],xv[11]);

  tmpi=__fpmul(av[32],xv[9]);
  tmpi=__fpmadd( tmpi,av[8  ],xv[1 ]);
  tmpi=__fpnmsub(tmpi,av[9  ],xv[0 ]);
  tmpi=__fpmadd( tmpi,av[16 ],xv[3 ]);
  tmpi=__fpnmsub(tmpi,av[17 ],xv[2 ]);
  tmpi=__fpmadd( tmpi,av[24 ],xv[5 ]);
  tmpi=__fpnmsub(tmpi,av[25 ],xv[4 ]);
  tmpi=__fpmadd( tmpi,av[28 ],xv[7 ]);
  tmpi=__fpnmsub(tmpi,av[29 ],xv[6 ]);
  tmpi=__fpmadd(tmpi,av[34 ],xv[11]);
  tmpi=__fpmadd(tmpi,av[35 ],xv[10]);
  x[10+0]=__creal(tmpr);
  x[10+4]=__cimag(tmpr);
  x[10+1]=__creal(tmpi);
  x[10+5]=__cimag(tmpi);

  // y6 = conjg(a(6)) * x1 + conjg(a(10)) * x2 + conjg(a(14)) * x3 + conjg(a(16)) * x4 + conjg(a(18)) * x5 + aimag(a(17)) * x6
  tmpr=__fpmul(av[33],xv[10]);
  tmpr=__fpmadd( tmpr,av[10 ],xv[0 ]);
  tmpr=__fpmadd( tmpr,av[11 ],xv[1 ]);
  tmpr=__fpmadd( tmpr,av[18 ],xv[2 ]);
  tmpr=__fpmadd( tmpr,av[19 ],xv[3 ]);
  tmpr=__fpmadd( tmpr,av[26 ],xv[4 ]);
  tmpr=__fpmadd( tmpr,av[27 ],xv[5 ]);
  tmpr=__fpmadd( tmpr,av[30 ],xv[6 ]);
  tmpr=__fpmadd( tmpr,av[31 ],xv[7 ]);
  tmpr=__fpmadd( tmpr,av[34 ],xv[8 ]);
  tmpr=__fpmadd( tmpr,av[35 ],xv[9 ]);

  tmpi=__fpmul(av[33],xv[11]);
  tmpi=__fpmadd( tmpi,av[10 ],xv[1 ]);
  tmpi=__fpnmsub(tmpi,av[11 ],xv[0 ]);
  tmpi=__fpmadd( tmpi,av[18 ],xv[3 ]);
  tmpi=__fpnmsub(tmpi,av[19 ],xv[2 ]);
  tmpi=__fpmadd( tmpi,av[26 ],xv[5 ]);
  tmpi=__fpnmsub(tmpi,av[27 ],xv[4 ]);
  tmpi=__fpmadd( tmpi,av[30 ],xv[7 ]);
  tmpi=__fpnmsub(tmpi,av[31 ],xv[6 ]);
  tmpi=__fpmadd( tmpi,av[34 ],xv[9 ]);
  tmpi=__fpnmsub(tmpi,av[35 ],xv[8 ]);
  x[18+0]=__creal(tmpr);
  x[18+4]=__cimag(tmpr);
  x[18+1]=__creal(tmpi);
  x[18+5]=__cimag(tmpi);
}
/*
 * this for non chiral gamma notation
 * not finished yet
 * but is slow
 *

typedef struct
{
  double c[2];
} d2 __attribute__ ((aligned (16)));

void clover_mult_ao_vec(double* a, double* x)
{
  //  vector double av[36];
  d2 av[36];
  unsigned i,j;
  for (i=0; i<36; ++i){
    for (j=0; j<2; ++j){
      av[i].c[j] = a[i+36*j];
    }
  }
  d2 xv[12];
       xv[0].c[0] = x[0]+x[4];
       xv[1].c[0] = x[1]+x[5];
       xv[2].c[0] = x[8+0]+x[8+4];
       xv[3].c[0] = x[8+1]+x[8+5];
       xv[4].c[0] = x[16+0]+x[16+4];
       xv[5].c[0] = x[16+1]+x[16+5];
       xv[6].c[0] = x[2+0]+x[2+4];
       xv[7].c[0] = x[2+1]+x[2+5];
       xv[8].c[0] = x[10+0]+x[10+4];
       xv[9].c[0] = x[10+1]+x[10+5];
      xv[10].c[0] = x[18+0]+x[18+4];
      xv[11].c[0] = x[18+1]+x[18+5];
       xv[0].c[1] = x[0]-x[4];
       xv[1].c[1] = x[1]-x[5];
       xv[2].c[1] = x[8+0]-x[8+4];
       xv[3].c[1] = x[8+1]-x[8+5];
       xv[4].c[1] = x[16+0]-x[16+4];
       xv[5].c[1] = x[16+1]-x[16+5];
       xv[6].c[1] = x[2+0]-x[2+4];
       xv[7].c[1] = x[2+1]-x[2+5];
       xv[8].c[1] = x[10+0]-x[10+4];
       xv[9].c[1] = x[10+1]-x[10+5];
      xv[10].c[1] = x[18+0]-x[18+4];
      xv[11].c[1] = x[18+1]-x[18+5];
}
*/
