/*
!===============================================================================
!
! ildg.h
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2007 Hinnerk Stueben
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
*/

/* naming coventions for C function called from Fortran */

#ifdef NamesToLower
# define ILDG_OPEN_R ildg_open_r
# define ILDG_OPEN_W ildg_open_w
# define ILDG_READ   ildg_read
# define ILDG_WRITE  ildg_write
# define ILDG_CLOSE_R  ildg_close_r
# define ILDG_CLOSE_W  ildg_close_w
#endif

#ifdef NamesToLower_
# define ILDG_OPEN_R ildg_open_r_
# define ILDG_OPEN_W ildg_open_w_
# define ILDG_READ   ildg_read_
# define ILDG_WRITE  ildg_write_
# define ILDG_CLOSE_R  ildg_close_r_
# define ILDG_CLOSE_W  ildg_close_w_
#endif

#ifdef NamesToLower__
# define ILDG_OPEN_R ildg_open_r__
# define ILDG_OPEN_W ildg_open_w__
# define ILDG_READ   ildg_read__
# define ILDG_WRITE  ildg_write__
# define ILDG_CLOSE_R  ildg_close_r__
# define ILDG_CLOSE_W  ildg_close_w__
#endif


/* prototypes for those functions */

void ILDG_OPEN_R(char *filename,
		 int *Lx, int *Ly, int *Lz, int *Lt,
		 int *precision,
		 INT8 *bytes_total);
void ILDG_OPEN_W(char *filename,
		 int *Lx, int *Ly, int *Lz, int *Lt,
		 int *precision,
		 INT8 *bytes_total);
void ILDG_READ(void *buffer, INT8 *bytes);
void ILDG_WRITE(void *buffer, INT8 *bytes);
void ILDG_CLOSE_R(INT8 *cksum, INT8 *bytes_total, char *lfn, int *len);
void ILDG_CLOSE_W(INT8 *cksum, INT8 *bytes_total, char *lfn);


/* prototypes for C functions called from C */

void ildg_find_record(char *record);
void ildg_read_string(char *record, char *s, int len);

/*===========================================================================*/
