!===============================================================================
!
! ildg_seq_r8.F90 - order gauge field in ILDG sequence 
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2007-2008 Hinnerk Stueben
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

!-------------------------------------------------------------------------------
subroutine ildg_seq_r8(action, u, u_ildg)  ! arranges u-field for i/o

  use module_lattice_io
  use module_decomp
  use module_vol
  implicit none

  character(*)     :: action
  GAUGE_FIELD      :: u
  GAUGE_FIELD_ILDG :: u_ildg

  integer, dimension(DIM) :: j
  integer :: x, y, z, t, i, eo, mu, c1, c2
  integer, external :: std_xyzt2i, e_o

  do t = 0, NT - 1
     do z = 0, NZ - 1
        do y = 0, NY - 1
           do x = 0, NX - 1

              j = (/x, y, z, t/)

              i = std_xyzt2i(j)
              eo = e_o(j)

              do mu = 1, DIM
                 do c2 = 1, NCOL
                    do c1 = 1, NCOL
                       if (action == "read") then
                          u(c1, c2, i, eo, mu) = u_ildg(c2, c1, mu, x, y, z, t)
                       else
                          u_ildg(c2, c1, mu, x, y, z, t) = u(c1, c2, i, eo, mu)
                       endif
                    enddo
                 enddo
              enddo
           enddo
        enddo
     enddo
  enddo
end

!===============================================================================
