/*
!===============================================================================
!
! cksum.h
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2007 Hinnerk Stueben
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
*/

/* naming coventions for C function called from Fortran */

#ifdef NamesToLower
# define CKSUM_INIT cksum_init
# define CKSUM_ADD cksum_add
# define CKSUM_GET cksum_get
#endif

#ifdef NamesToLower_
# define CKSUM_INIT cksum_init_
# define CKSUM_ADD cksum_add_
# define CKSUM_GET cksum_get_
#endif

#ifdef NamesToLower__
# define CKSUM_INIT cksum_init__
# define CKSUM_ADD cksum_add__
# define CKSUM_GET cksum_get__
#endif

/* prototypes for those functions */

void CKSUM_INIT(void);
void CKSUM_ADD(void *, INT8 *);
void CKSUM_GET(INT8 *, INT8 *);

/*===========================================================================*/
