#ifndef BQCD_DEFS_C_H
#define BQCD_DEFS_C_H

# define DIM    4
# define NCOL   3
# define NDIRAC 4
# define NGEN   8
# define EVEN   0
# define ODD    1
# define FWD    0
# define BWD    1

# define SIZE_COMPLEX 2

# define FWD_BWD 2
# define EVEN_ODD 2

typedef double REAL;
typedef int INTEGER;
typedef struct { REAL r; REAL i; } COMPLEX;
typedef COMPLEX SU3[NCOL][NCOL];
typedef REAL GENERATOR[NGEN];

typedef COMPLEX SPINCOL_FIELD[][NCOL][NDIRAC];
typedef struct { COMPLEX (*sc)[NCOL][2]; } SC2_FIELD[FWD_BWD][DIM]; 
typedef struct { INTEGER (*nn)[DIM]; } NN2[FWD_BWD][EVEN_ODD]; 

# define Re(z) (z).r
# define Im(z) (z).i

# define CAT(A, B) A ## B
# define STRCAT(A, B) CAT(A, B)
# define STRCAT3(A, B, C) STRCAT(STRCAT(A, B), C)
# define STRING(s) SSTRING(s)
# define SSTRING(s) #s

# define ZERO  0.0
# define ONE   1.0

#endif
