!===============================================================================
!
! hmc_init_p.F90 - initialisation of momenta
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 1998-2003 Hinnerk Stueben
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

!-------------------------------------------------------------------------------
subroutine hmc_init_p(p)
  use module_p_interface
  use module_vol
  implicit none

  GENERATOR_FIELD, intent(out) :: p
  integer                      :: mu, eo,i

!  P_GAUGE_FIELD,save:: tmp
  SU3 :: w

  TIMING_START(timing_bin_hmc_init_p)
!  ALLOCATE_G_FIELD(tmp)
p=ZERO
  do mu = 1, DIM
     do eo = EVEN, ODD
        call ran_gauss_volh(NGEN/2, p(1,1,eo,mu), ONE, eo)
     enddo
  enddo

  call nonactive(p) !! for ddhmc

!  do mu = 1, DIM
!     do eo = EVEN, ODD
!        call ran_gauss_volh(9, tmp(1,1,1,eo,mu), HALF, eo)
!     enddo
!  enddo
!p=ZERO
!  do mu = 1, DIM
!     do eo = EVEN, ODD
!        !$omp parallel do private(w)
!        do i = 1, volh
!           call traceless_antihermit(w, tmp(1,1,i,eo,mu) )
!           call im_tr_j(p(1, i, eo, mu), w, HALF)
!        enddo
!     enddo
!  enddo


  TIMING_STOP(timing_bin_hmc_init_p)
end

!===============================================================================
