!===============================================================================
!
! cdotc_12.F90
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2007 Yoshifumi Nakamura
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

!-------------------------------------------------------------------------------
COMPLEX function cdotc_12(x, y)  ! Sum_i conjg(x_i) * y_i

  implicit none
  COMPLEX, intent(in) :: x(*), y(*)
  COMPLEX             :: tmp 
  integer             :: i
 
  tmp = ZERO
  !$omp parallel do reduction(+: tmp)
  do i = 1, 12
     tmp = tmp + conjg(x(i)) * y(i)
  enddo

  cdotc_12 = tmp

end

!===============================================================================
