!===============================================================================
!
! change_info_file.F90
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2007-2008 Yoshifumi Nakamura
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

!-------------------------------------------------------------------------------
subroutine change_info_file(itraj, para, conf)
  use module_input
  use module_field

  use typedef_para
  use module_counter
  use module_switches
  implicit none
  type(type_para),                         intent(inout) :: para
  type(hmc_conf),   dimension(MAX_TEMPER), intent(inout) :: conf
  integer, intent(in) :: itraj
  FILENAME, external :: conf_info_file_ieiepname

  counter%traj = input%measurement_start_traj + para%nsave * (itraj - 1)
  para%info_file = conf_info_file_ieiepname(1, 1, trim(input%measurement_file_name))

!!  call conf_read(.false., para, conf)
!!  gauge(1)%u => conf(1)%u
!!  gauge(1:size(gauge))%init = .true.
!!  if(associated(stout) )stout(1:size(stout))%init = .true.
!!  if(associated(clover))clover(1:size(clover))%init = .true.

end

!-------------------------------------------------------------------------------
FILENAME function conf_info_file_ieiepname(i1, i2, pname)

  use module_counter
  implicit none

  integer, intent(in)            :: i1, i2
  character(len = *), intent(in) :: pname
  character(len = 2) :: fmt_name     = "(a"
  character(len = 2) :: fmt_ext      = "a)"
  character(len = 5) :: fmt_sep      = ",'.',"
  character(len = 4) :: fmt_traj     = "i5.5"
  character(len = 4) :: fmt_run      = "i3.3"
  character(len = 4) :: fmt_ensemble = "i1.1"
  FILENAME_FORMAT :: fmt

  fmt = fmt_name // fmt_sep // &
        fmt_run  // fmt_sep // &
        fmt_ensemble // fmt_sep // &
        fmt_ensemble // fmt_sep // &
        fmt_traj // fmt_sep // &
        fmt_ext
  
  write(conf_info_file_ieiepname, fmt) &
     pname, counter%run, i1, i2, counter%traj, "info"

end

!===============================================================================
