!===============================================================================
!
! correlation_tt.F90
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2007 Yoshifumi Nakamura
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"
# include "defs_imp_2p1.h"

!-------------------------------------------------------------------------------
COMPLEX function correlation_tt(t0,dis,in1,in2)

  use module_decomp
  implicit none
  integer,          intent(in) :: t0, dis
  COMPLEX_FIELD_ST, intent(in) :: in1,in2
  integer, external :: std_xyzt2i, e_o
  integer :: vols ,t, t1, , coord(DIM)


  nx = decomp%std%N(1)
  ny = decomp%std%N(2)
  nz = decomp%std%N(3)
  nt = decomp%std%N(4)


  vols = NX*NY*NZ
  t1 = dis + t0
  tt = dis / NT
  tr = mod(dis,NT)

  npe(1) = LX/NX
  npe(2) = LY/NY
  npe(3) = LZ/NZ

  do xx = 0, npe(1) - 1
  do yy = 0, npe(2) - 1
  do zz = 0, npe(3) - 1
     pe_shift =  nnpe(xx, yy, zz, tt)

     do i = 1, vols
        do j = 1, vols
           in1(i, t0)*in2(j, tr)
        enddo
     enddo


  correlation_tt = ZERO

end

!===============================================================================
