!===============================================================================
!
! ppp.F90
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2007 Yoshifumi Nakamura
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"
# include "defs_imp_2p1.h"

!-------------------------------------------------------------------------------
subroutine ppp(tmp,tmp_e,tmp_o,name)

  use module_function_decl
  use module_lattice_io
  use module_decomp
  use module_vol
  implicit none
  SPINCOL_FIELD,intent(in)    :: tmp_e,tmp_o
  SPINCOL_FIELD_XYZT,intent(out) :: tmp

  character(len=3) :: name
  integer, dimension(DIM) :: j
  integer :: x, y, z, t, i, eo, mu, c
  integer, external :: std_xyzt2i, e_o

  do t = 0, NT - 1
     do z = 0, NZ - 1
        do y = 0, NY - 1
           do x = 0, NX - 1

              j = (/x, y, z, t/)

              i = std_xyzt2i(j)
              eo = e_o(j)

              do mu = 1, DIM
                 do c = 1, NCOL
!                    if (action == "read") then
!                       u(c1, c2, i, eo, mu) = u_io(c1, c2, mu, x, y, z, t)
!                    else
                       if (eo == EVEN )tmp(mu, c, x, y, z, t) = tmp_e(mu, c, i)
                       if (eo == ODD  )tmp(mu, c, x, y, z, t) = tmp_o(mu, c, i)
!                    endif
                 enddo
              enddo
           enddo
        enddo
     enddo
  enddo

if (my_pe()==0)then
  do t = 0, 0!NT - 1
     do z = 0, 0!NZ - 1
        do y = 0, 0!NY - 1
           do x = 0, 0!NX - 1
              do c = 1, 3
                 do mu = 1, 4
                 if (Re(tmp(mu,c,x,y,z,t)) /= ZERO .or.&
                     Im(tmp(mu,c,x,y,z,t)) /= ZERO )&
                 write(*,100)"%%%",name,& 
                 my_pe(),mu,c,x,y,z,t, &
                 Re(tmp(mu,c,x,y,z,t)),Im(tmp(mu,c,x,y,z,t))
                 enddo
              enddo
           enddo
        enddo
     enddo
  enddo
endif

100 format (1x, 2a, 7i3, 2ES17.7)

end

!===============================================================================
