!===============================================================================
!
! reduction_space.F90
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2007 Yoshifumi Nakamura
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

!-------------------------------------------------------------------------------
subroutine reduction_eo_std(out,in_e,in_o)

  use module_decomp
  use module_vol
  implicit none
  COMPLEX, dimension(volh), intent(in)  :: in_e,in_o
  COMPLEX, dimension(vol ), intent(out) :: out

  integer, dimension(DIM) :: j
  integer :: x, y, z, t, i, eo, icount
  integer :: nx, ny, nz, nt
  integer, external :: std_xyzt2i, e_o

  nx = decomp%std%N(1)
  ny = decomp%std%N(2)
  nz = decomp%std%N(3)
  nt = decomp%std%N(4)

  icount = 1
  do t = 0, nt - 1
     do z = 0, nz - 1
        do y = 0, ny - 1
           do x = 0, nx - 1
              j = (/x, y, z, t/)
              i = std_xyzt2i(j)
              eo = e_o(j)
              if (eo == EVEN )out(icount) = in_e(i)
              if (eo == ODD  )out(icount) = in_o(i)
              icount = icount + 1
           enddo
        enddo
     enddo
  enddo

end

!===============================================================================
