!===============================================================================
!
! module_ildg.F90 - ILDG code metadata
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2008 Hinnerk Stueben 
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------

module module_ildg

  use module_svn
  use module_bqcd

  private :: svn_date, svn_revision
  private :: prog_name, prog_version, prog_revision
  private :: input_version, conf_info_version
  
  character(*), parameter :: ildg_code_name = "BQCD"
  character(*), parameter :: ildg_code_version = prog_version
  character(*), parameter :: ildg_code_revision = prog_revision
  character(25),parameter :: ildg_code_date = svn_date(8:17) // &
                                              "T" // &
                                              svn_date(19:26) // &
                                              svn_date(28:30) // &
                                              ":" // &
                                              svn_date(31:32)
end

!===============================================================================

