!===============================================================================
!
! module_surface.F90  -  lists of surface sites
!                        
! surface(even_or_odd, mu, direction) contains indices of even_or_odd 
! sites which have to be communicated to the process in mu-direction.
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2003-2007 Hinnerk Stueben 
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

!-------------------------------------------------------------------------------
module module_surface

  type type_surface
     integer :: nsites
     INTEGER, dimension(:), pointer :: site
  end type type_surface

  type(type_surface), save :: surface(EVEN:ODD, DIM, FWD:BWD)
  type(type_surface), save :: surface_halo(EVEN:ODD, DIM, FWD:BWD)

end

!===============================================================================
