!===============================================================================
!
! typedef.F90
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2008 Yoshifumi Nakamura 
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

# define P_GAUGE_FIELD_R4    complex(4), dimension(:, :, :, :, :), pointer
# define P_CLOVER_FIELD_A_R4 type(type_clover_a_r4), dimension(:, :, :), pointer
# define P_CLOVER_FIELD_B_R4 type(type_clover_b_r4), dimension(:, :, :), pointer

!-------------------------------------------------------------------------------
module typedef
  use typedef_clover
  use typedef_clover_r4

  type :: sc_field
     P_SPINCOL_FIELD :: sc
     P_SPINCOL_FIELD :: sc_e
     P_SPINCOL_FIELD :: sc_o
     COMPLEX, dimension(:, :, :, :, :), pointer :: ddsc
  end type sc_field

  type :: sco_field
     P_SPINCOL_OVERINDEXED :: sco
  end type sco_field

  type gauge_field
     logical :: init
     integer :: sid
!#ifdef RIKEN
!     complex(8), dimension(:, :, :, :, :), allocatable ::u
!#else
     P_GAUGE_FIELD    :: u
!#endif
  end type gauge_field

  type clover_field
     logical :: init
     integer :: nf
     REAL    :: kappa, csw, cswkappa, theta
     P_CLOVER_FIELD_A :: a
     P_CLOVER_FIELD_A :: i
     P_CLOVER_FIELD_B :: b
  end type clover_field

  type gauge_field_r4
     logical :: init
     integer :: sid
     P_GAUGE_FIELD_R4 :: u
  end type gauge_field_r4

  type clover_field_r4
     logical :: init
     integer :: nf
     real(4) :: kappa, csw, cswkappa, theta
     P_CLOVER_FIELD_A_R4 :: a
     P_CLOVER_FIELD_A_R4 :: i
     P_CLOVER_FIELD_B_R4 :: b
  end type clover_field_r4

end

!===============================================================================
