!===============================================================================
!
! typedef_hmc_r4.F90
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2008 Hinnerk Stueben 
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# define PRECISION_R4
# include "defs_r4.h"
# include "defs.h"

module typedef_hmc_r4

  use typedef_clover

  type hmc_conf
     P_GAUGE_FIELD    :: u
     P_SPINCOL_FIELD  :: phi
     P_SPINCOL_FIELD  :: phi2
     P_CLOVER_FIELD_A :: a       ! A := 1 - kappa c_sw sigma F (in 6x6 blocks)
     P_CLOVER_FIELD_A :: i       ! inverse of A
     P_CLOVER_FIELD_B :: b       ! inverse of A in (L D L+) decomposed form
     integer          :: former  ! ensemble index before tempering
  end type hmc_conf

end

!===============================================================================
