!===============================================================================
!
! service-EXPLANIED.F90
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 1998-2008 Hinnerk Stueben
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

!-------------------------------------------------------------------------------
subroutine abbruch()  ! exit with error status and shutdown parallel application
                      ! can be mpi_abort(1) when using MPI
  call errexit()
end

!-------------------------------------------------------------------------------
SECONDS function sekunden()  ! returns CPU-seconds
                             ! SECONDS has to be defined in "defs.h"
  sekunden = tsecnd()
end

!-------------------------------------------------------------------------------
! Arguments from the command line (the following works on many machines):
!-------------------------------------------------------------------------------
subroutine pxfgetarg(iarg, arg, larg, status)  ! iarg = 0 ==> command name
                                               ! iarg > 0 ==> argument
  implicit none
  integer :: iarg, larg, status
  character(len = *) :: arg
  character(len(arg) + 1) :: a

  call getarg(iarg, a)

  larg = len_trim(a)
  arg = a
  status = 0
end

!-------------------------------------------------------------------------------
integer function ipxfargc()     ! ipxfargc = 0 ==> no arguments
  ipxfargc = iargc()            ! ipxfargc > 0 ==> number of arguments
end

!-------------------------------------------------------------------------------
logical function is_big_endian()  ! .false. on e.g. Intel 
  is_big_endian = .true.
end

!===============================================================================
