!===============================================================================
!
! service-ibm.F90 - calls to service routines on IBM
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2002 Hinnerk Stueben
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

!-------------------------------------------------------------------------------
subroutine abbruch()

  integer(4) status
  status = 1
  call exit_(status)
end

!-------------------------------------------------------------------------------
function rechner()  ! returns hostname

  character(len = 20) rechner
  character(len = 32) r

  call hostnm_(r)
  rechner = r
end

!-------------------------------------------------------------------------------
SECONDS function sekunden()

  real(8) rtc

  sekunden = rtc()  !!!mclock() * 0.01
end

!-------------------------------------------------------------------------------
subroutine pxfgetarg(iarg, arg, larg, status)

  implicit none
  integer :: iarg, larg, status
  integer(4) :: i 
  character(len = *) :: arg
  character(len(arg) + 1) :: a

  i = iarg
  call getarg(i, a)

  larg = len_trim(a)
  arg = a
  status = 0
end

!-------------------------------------------------------------------------------
integer function ipxfargc()
  integer(4) :: iargc
  ipxfargc = iargc()
end

!-------------------------------------------------------------------------------
logical function is_big_endian()
  is_big_endian = .true.
end

!===============================================================================
