!===============================================================================
!
! init_sc.F90
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2003 Hinnerk Stueben
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

!-------------------------------------------------------------------------------
module module_sc_size

  integer :: sc_n_real     ! number of real numbers of an sc-field
  integer :: sc_n_complex  ! number of complex numbers of an sc-field

end

!-------------------------------------------------------------------------------
subroutine init_module_sc_size()

  use module_sc_size
  use module_vol
  implicit none
  
  sc_n_complex = NDIRAC * NCOL * volh
  sc_n_real = NDIRAC * NCOL * volh * SIZE_COMPLEX

end

!-------------------------------------------------------------------------------
module module_sc_size_r4

  integer :: sc_n_real     ! number of real numbers of an sc-field
  integer :: sc_n_complex  ! number of complex numbers of an sc-field

end

!-------------------------------------------------------------------------------
subroutine init_module_sc_size_r4()

  use module_sc_size_r4
  use module_vol
  implicit none
  
  sc_n_complex = NDIRAC * NCOL * volh
  sc_n_real = NDIRAC * NCOL * volh * SIZE_COMPLEX

end

!===============================================================================
