/*
!===============================================================================
!
! place_proc_linux.c
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2008 Hinnerk Stueben
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
*/
#define _GNU_SOURCE

#include <sched.h>
#include <syscall.h>

void place_proc_(int *cpu)
{
    cpu_set_t mask;

    CPU_ZERO(&mask);
    CPU_SET(*cpu, &mask);

    sched_setaffinity(syscall(SYS_gettid), 
                      sizeof(cpu_set_t) / sizeof(__cpu_mask), &mask);

}
